(ns src.frontend.portfolio.stability-ai
  (:require ;[clj-http.client :as client]
            [ajax.core :refer [GET POST]]
            [portfolio.ui :as ui]
            [portfolio.dumdom :as d]
            [portfolio.dom :as r]))

;; api root paths shoudl not end in a slash
;; the payloads should be maps no coupling to http libraries
;; each api should have an init to set the api key and change the host along side any other config
 

(def api-host "https://api.stability.ai")
(def api-key "")

(def default-authed-payload {:headers {"Authorization" (str "Bearer " api-key)
                                       "content-type" "application/json"}})

(defn build-url [path]
  (str api-host path))



(GET (build-url "/v1/user/account")
     (merge default-authed-payload
            {:handler prn}))

(GET (build-url "/v1/user/balance")
     (merge default-authed-payload
            {:handler prn}))

(def temp-response (atom nil))

(POST (build-url "/v1/generation/stable-diffusion-v1-5/text-to-image")
     (merge default-authed-payload
            {:handler (fn [r]
                        (prn r)
                        (reset! temp-response r))
             :format :json
             :response-format :json
             :params {:text_prompts [{:text "A wooden hand crafted light house"
                                      :weight 0.5}]}
             }))



(d/defscene image
  [:div
   [:img {:src (str "data:image/png;base64," (get (first (get @temp-response "artifacts")) "base64")) }]])

(d/defscene card
  [:div.h-96.w-48.flex.justify-center.flex.col.rounded-full.border
   [:div.w-48.h-48
    [:img.object-contain.w-48.h-48.rounded-md
     {:src (str "data:image/png;base64," (get (first (get @temp-response "artifacts")) "base64")) }]]
   [:div "some text"]])

@temp-response

